com.smartgwt.client.types

## Enum PreserveOpenState

- java.lang.Object
- - java.lang.Enum<PreserveOpenState>
  - - com.smartgwt.client.types.PreserveOpenState

- All Implemented Interfaces:
    ValueEnum, java.io.Serializable, java.lang.Comparable<PreserveOpenState>

      public enum PreserveOpenState
      extends java.lang.Enum<PreserveOpenState>
      implements ValueEnum

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ALWAYS` Like "whenUnique" but automatically preserves openState even if nodes cannot be uniquely identified.
    `NEVER` Never try to automatically preserve the openState.
    `WHENUNIQUE` If either the `idField` or `nameProperty` has been set on the Tree, (so that nodes have either unique ids or unique paths), preserve openState by respecting the `openProperty` set by the server, then applying the openState.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getValue()`
    `static PreserveOpenState` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static PreserveOpenState[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### NEVER

          public static final PreserveOpenState NEVER

      Never try to automatically preserve the openState. Nodes will be initially open or closed based solely on the `openProperty` optionally set by the server.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "never".

    - #### WHENUNIQUE

          public static final PreserveOpenState WHENUNIQUE

      If either the `idField` or `nameProperty` has been set on the Tree, (so that nodes have either unique ids or unique paths), preserve openState by respecting the `openProperty` set by the server, then applying the openState.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "whenUnique".

    - #### ALWAYS

          public static final PreserveOpenState ALWAYS

      Like "whenUnique" but automatically preserves openState even if nodes cannot be uniquely identified. This means that nodes at the same tree positions (eg 3rd child of 5th node under root) will be placed in the same openState, regardless of whether that node has anything to do with the node that previously was at that tree position.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "always".

  - ### Method Detail

    - #### values

          public static PreserveOpenState[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (PreserveOpenState c : PreserveOpenState.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static PreserveOpenState valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getValue

          public java.lang.String getValue()

      Specified by:
        `getValue` in interface `ValueEnum`